#pragma once

#include <iostream>

namespace spin
{
    // TODO: set, get and compare software versions for bridge and cbun.
    struct SoftwareVersion
    {
        static SoftwareVersion parse(std::string softwareVersionString)
        {
            return SoftwareVersion(softwareVersionString);
        }

        inline friend std::ostream &operator<<(std::ostream &out, const SoftwareVersion &softwareVersion)
        {
            out << softwareVersion.softwareVersion_ << std::endl;
            return out;
        }

        inline std::string toString() const { return softwareVersion_; }

        inline bool operator==(const SoftwareVersion &other) const
        {
            return softwareVersion_ == other.softwareVersion_;
        }

    private:
        SoftwareVersion(std::string softwareVersionString) : softwareVersion_(softwareVersionString) {}
        const std::string softwareVersion_;
    };

} // namespace spin